#include <cstdio>

using namespace std;

const char *dirs = "URDL";
const int dy[] = {-1, 0, 1, 0};
const int dx[] = {0, 1, 0, -1};
const int MAXN = 1024;
const int MAXM = 1024;

int N, M;
int X, Y;
char dir;
int A[MAXN][MAXM];
bool B[4][MAXN][MAXM];

inline int index(char a) {
  if ( a == 'U' ) return 0;
  if ( a == 'R' ) return 1;
  if ( a == 'D' ) return 2;
  return 3;
}

int forward(char dir, char *newdir) {
	*newdir = dir;
	return index(dir);
}

int turnleft(char dir, char *newdir) {
	if ( dir == 'U' ) { *newdir = 'L'; return 3; }
	if ( dir == 'D' ) { *newdir = 'R'; return 1; }
	if ( dir == 'L' ) { *newdir = 'D'; return 2; }
	*newdir = 'U'; return 0;
}

int turnright(char dir, char *newdir) {
	if ( dir == 'U' ) { *newdir = 'R'; return 1; }
	if ( dir == 'D' ) { *newdir = 'L'; return 3; }
	if ( dir == 'L' ) { *newdir = 'U'; return 0; }
	*newdir = 'D'; return 2;
}

int turnover(char dir, char *newdir) {
	if ( dir == 'U' ) { *newdir = 'D'; return 2; }
	if ( dir == 'D' ) { *newdir = 'U'; return 0; }
	if ( dir == 'L' ) { *newdir = 'R'; return 1; }
	*newdir = 'L'; return 3;
}

int (*f[])(char, char*) = { forward, turnleft, turnright, turnover };

int main () {
	
	scanf ("%d %d %d %d %c", &N, &M, &Y, &X, &dir);
	
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j)
			scanf ("%d", &A[i][j]);

	int steps = 0;	
	while ( true ) {
	  //	  printf (" (%c %d %d)\n", dir, Y, X);
	  for (int i = 0; i < 4; ++i) {
		char newdir;
		int ff = (f[i])(dir, &newdir);
		int ty = Y + dy[ff];
		int tx = X + dx[ff];
		//			printf("%d %d\n", ty, tx);
		if ( ty < 0 || tx < 0 || ty >= N || tx >= M ) {
			printf ("%d %d %c %d\n", Y, X, dir, steps+1);
			return 0;
		}

		if ( B[ index(newdir) ][ty][tx] || A[ty][tx] == -1 ) {
		  puts ("-1");
		  return 0;
		}
		B[ index(newdir) ][ty][tx] = true;
		if ( A[ty][tx] == 0 ) {
			Y = ty;
			X = tx;
			dir = newdir;
			steps++;
			break;				
		}
	  }
       }

	return 0;
}
