#include <cstdio>
#include <climits>

struct stack {
  int data[64];
  int len;

  int pop() {
    return data[--len];
  }
  void push(int val) {
    data[len++] = val;
  }
  int top() {
    return data[len-1];
  }
};

int heights[64], n;
double water[64];

stack hstack;

double fmin(double a, double b) {
	return a < b ? a : b;
}
int min(int a, int b) {
	return a < b ? a : b;
}
int max(int a, int b) {
	return a > b ? a : b;
}

int main() {
	scanf("%d", &n);
	hstack.push(0);
	heights[0] = 15200;
	for(int i = 1; i < n; ++i)
		scanf("%d", &heights[i]);
	heights[n] = 15200;
	double amount;
	scanf("%lf", &amount);
	for(int i = 1; i <= n; ++i) {
		if(heights[i] <= heights[hstack.top()]) {
			double tofill = fmin(amount, heights[i]);
			water[i-1] += tofill;
			amount -= tofill;
			hstack.push(i);
		} else {
			while(amount > 0) {
				int cols = i - hstack.top();
				if(heights[i] >= heights[hstack.top()]) {
					double htofill = heights[hstack.top()] - water[i-1];
					double tofill = fmin(amount, cols*htofill);
					for(int k = i-1; k >= hstack.top(); --k) {
						water[k] += tofill/cols;
					}
					amount -= tofill;
					if(heights[i] < heights[hstack.top()])
						break;
					hstack.pop();
				} else {
					double htofill = heights[i] - water[i-1];
					double tofill = fmin(amount, cols*htofill);
					for(int k = i-1; k >= hstack.top(); --k) {
						water[k] += tofill/cols;
					}
					amount -= tofill;
					break;
				}
			}
			hstack.push(i);
		}
		if(amount <= 0)
			break;
	}
	printf("%lf", water[0]);
	for(int i = 1; i < n; ++i) {
		printf(" %lf", water[i]);
	}
	printf("\n");
	return 0;
}